#######################################################
# FUNCTION: d_ab2i                       
# Get indices d_i of elements d_ab to reference in
# the contrast vector.
#
# ARGUMENTS:
#  a    = Treatment code a
#  b    = Treatment code b
#  K    = Total number of treatments
#
# AUTHOR: David M. Phillippo, 
#         University of Bristol
#######################################################

d_ab2i <- function(a,b,K){
  stopifnot(b>a,a<K,b<=K,a>=1,b>=2,length(a)==length(b))
  
  #sum(1:(K-1)) - sum(1:(K-a[i])) + (b-a)
  sum(1:(K-1)) - sapply((sapply(K-a,seq,from=1)),sum) + (b-a)
}
